using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using ZylGPSReceiver;

namespace CSharpDemo
{	
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnOpen;
		private System.Windows.Forms.Button btnClose;	
		private System.Windows.Forms.ListBox lstPorts;

		private System.Windows.Forms.TextBox textBoxOut;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.TextBox textBoxSatCount;
		private System.Windows.Forms.TextBox textBoxHeading;
		private System.Windows.Forms.TextBox textBoxSpeed;
		private System.Windows.Forms.TextBox textBoxAlt;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox textBoxLongDir;
		private System.Windows.Forms.TextBox textBoxLongSec;
		private System.Windows.Forms.TextBox textBoxLongMin;
		private System.Windows.Forms.TextBox textBoxLongDeg;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBoxLatDir;
		private System.Windows.Forms.TextBox textBoxLatSec;
		private System.Windows.Forms.TextBox textBoxLatMin;
		private System.Windows.Forms.TextBox textBoxLatDeg;
		private ZylGPSReceiver.GPSReceiver gpsReceiver;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Label lblLocalTime;
		private System.Windows.Forms.Label lblUTCTime;
        private PictureBox pBox;
        private ListBox lstBaudRate;
        private Label label15;
        private Label label16;
        private Button btnDetect;
        private Button btnCancel;
        private Label lblDetect;
		private System.ComponentModel.IContainer components;

        private bool m_DetectCancel = false;

        // This delegate enables asynchronous calls for setting
        // the text property on a TextBox control.
        delegate void SetTextCallback(string text);

        private delegate void RefreshPaintBoxCallBack();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.textBoxOut = new System.Windows.Forms.TextBox();
            this.lstPorts = new System.Windows.Forms.ListBox();
            this.btnOpen = new System.Windows.Forms.Button();
            this.btnClose = new System.Windows.Forms.Button();
            this.groupBox3 = new System.Windows.Forms.GroupBox();
            this.label12 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.textBoxSatCount = new System.Windows.Forms.TextBox();
            this.textBoxHeading = new System.Windows.Forms.TextBox();
            this.textBoxSpeed = new System.Windows.Forms.TextBox();
            this.textBoxAlt = new System.Windows.Forms.TextBox();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label8 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.textBoxLongDir = new System.Windows.Forms.TextBox();
            this.textBoxLongSec = new System.Windows.Forms.TextBox();
            this.textBoxLongMin = new System.Windows.Forms.TextBox();
            this.textBoxLongDeg = new System.Windows.Forms.TextBox();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.textBoxLatDir = new System.Windows.Forms.TextBox();
            this.textBoxLatSec = new System.Windows.Forms.TextBox();
            this.textBoxLatMin = new System.Windows.Forms.TextBox();
            this.textBoxLatDeg = new System.Windows.Forms.TextBox();
            this.label14 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.lblLocalTime = new System.Windows.Forms.Label();
            this.lblUTCTime = new System.Windows.Forms.Label();
            this.pBox = new System.Windows.Forms.PictureBox();
            this.lstBaudRate = new System.Windows.Forms.ListBox();
            this.label15 = new System.Windows.Forms.Label();
            this.label16 = new System.Windows.Forms.Label();
            this.btnDetect = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.lblDetect = new System.Windows.Forms.Label();
            this.gpsReceiver = new ZylGPSReceiver.GPSReceiver(this.components);
            this.groupBox3.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pBox)).BeginInit();
            this.SuspendLayout();
            // 
            // textBoxOut
            // 
            this.textBoxOut.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.textBoxOut.Location = new System.Drawing.Point(8, 87);
            this.textBoxOut.Multiline = true;
            this.textBoxOut.Name = "textBoxOut";
            this.textBoxOut.ReadOnly = true;
            this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.textBoxOut.Size = new System.Drawing.Size(296, 134);
            this.textBoxOut.TabIndex = 0;
            // 
            // lstPorts
            // 
            this.lstPorts.Items.AddRange(new object[] {
            "COM1",
            "COM2",
            "COM3",
            "COM4",
            "COM5",
            "COM6",
            "COM7",
            "COM8",
            "COM9",
            "COM10",
            "COM11",
            "COM12",
            "COM13",
            "COM14",
            "COM15",
            "COM16",
            "COM17",
            "COM18",
            "COM19",
            "COM20",
            "COM21",
            "COM22",
            "COM23",
            "COM24",
            "COM25"});
            this.lstPorts.Location = new System.Drawing.Point(8, 25);
            this.lstPorts.Name = "lstPorts";
            this.lstPorts.Size = new System.Drawing.Size(64, 56);
            this.lstPorts.TabIndex = 1;
            // 
            // btnOpen
            // 
            this.btnOpen.Location = new System.Drawing.Point(149, 32);
            this.btnOpen.Name = "btnOpen";
            this.btnOpen.Size = new System.Drawing.Size(75, 23);
            this.btnOpen.TabIndex = 2;
            this.btnOpen.Text = "Open";
            this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
            // 
            // btnClose
            // 
            this.btnClose.Location = new System.Drawing.Point(149, 58);
            this.btnClose.Name = "btnClose";
            this.btnClose.Size = new System.Drawing.Size(75, 23);
            this.btnClose.TabIndex = 3;
            this.btnClose.Text = "Close";
            this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
            // 
            // groupBox3
            // 
            this.groupBox3.Controls.Add(this.label12);
            this.groupBox3.Controls.Add(this.label11);
            this.groupBox3.Controls.Add(this.label10);
            this.groupBox3.Controls.Add(this.label9);
            this.groupBox3.Controls.Add(this.textBoxSatCount);
            this.groupBox3.Controls.Add(this.textBoxHeading);
            this.groupBox3.Controls.Add(this.textBoxSpeed);
            this.groupBox3.Controls.Add(this.textBoxAlt);
            this.groupBox3.Location = new System.Drawing.Point(8, 396);
            this.groupBox3.Name = "groupBox3";
            this.groupBox3.Size = new System.Drawing.Size(296, 72);
            this.groupBox3.TabIndex = 9;
            this.groupBox3.TabStop = false;
            // 
            // label12
            // 
            this.label12.Location = new System.Drawing.Point(224, 24);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(56, 16);
            this.label12.TabIndex = 7;
            this.label12.Text = "Sat Count";
            // 
            // label11
            // 
            this.label11.Location = new System.Drawing.Point(152, 24);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(56, 16);
            this.label11.TabIndex = 6;
            this.label11.Text = "Heading";
            // 
            // label10
            // 
            this.label10.Location = new System.Drawing.Point(80, 24);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(48, 16);
            this.label10.TabIndex = 5;
            this.label10.Text = "Speed";
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(8, 24);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(56, 16);
            this.label9.TabIndex = 4;
            this.label9.Text = "Altitude";
            // 
            // textBoxSatCount
            // 
            this.textBoxSatCount.Location = new System.Drawing.Point(224, 40);
            this.textBoxSatCount.Name = "textBoxSatCount";
            this.textBoxSatCount.ReadOnly = true;
            this.textBoxSatCount.Size = new System.Drawing.Size(64, 20);
            this.textBoxSatCount.TabIndex = 3;
            // 
            // textBoxHeading
            // 
            this.textBoxHeading.Location = new System.Drawing.Point(152, 40);
            this.textBoxHeading.Name = "textBoxHeading";
            this.textBoxHeading.ReadOnly = true;
            this.textBoxHeading.Size = new System.Drawing.Size(64, 20);
            this.textBoxHeading.TabIndex = 2;
            // 
            // textBoxSpeed
            // 
            this.textBoxSpeed.Location = new System.Drawing.Point(80, 40);
            this.textBoxSpeed.Name = "textBoxSpeed";
            this.textBoxSpeed.ReadOnly = true;
            this.textBoxSpeed.Size = new System.Drawing.Size(64, 20);
            this.textBoxSpeed.TabIndex = 1;
            // 
            // textBoxAlt
            // 
            this.textBoxAlt.Location = new System.Drawing.Point(8, 40);
            this.textBoxAlt.Name = "textBoxAlt";
            this.textBoxAlt.ReadOnly = true;
            this.textBoxAlt.Size = new System.Drawing.Size(64, 20);
            this.textBoxAlt.TabIndex = 0;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label8);
            this.groupBox2.Controls.Add(this.label7);
            this.groupBox2.Controls.Add(this.label6);
            this.groupBox2.Controls.Add(this.label5);
            this.groupBox2.Controls.Add(this.textBoxLongDir);
            this.groupBox2.Controls.Add(this.textBoxLongSec);
            this.groupBox2.Controls.Add(this.textBoxLongMin);
            this.groupBox2.Controls.Add(this.textBoxLongDeg);
            this.groupBox2.Location = new System.Drawing.Point(8, 316);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(296, 72);
            this.groupBox2.TabIndex = 8;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Longitude";
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(224, 24);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(56, 16);
            this.label8.TabIndex = 7;
            this.label8.Text = "Direction";
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(152, 24);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(56, 16);
            this.label7.TabIndex = 6;
            this.label7.Text = "Second";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(80, 24);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(56, 16);
            this.label6.TabIndex = 5;
            this.label6.Text = "Minute";
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 24);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(56, 16);
            this.label5.TabIndex = 4;
            this.label5.Text = "Degree";
            // 
            // textBoxLongDir
            // 
            this.textBoxLongDir.Location = new System.Drawing.Point(224, 40);
            this.textBoxLongDir.Name = "textBoxLongDir";
            this.textBoxLongDir.ReadOnly = true;
            this.textBoxLongDir.Size = new System.Drawing.Size(64, 20);
            this.textBoxLongDir.TabIndex = 3;
            // 
            // textBoxLongSec
            // 
            this.textBoxLongSec.Location = new System.Drawing.Point(152, 40);
            this.textBoxLongSec.Name = "textBoxLongSec";
            this.textBoxLongSec.ReadOnly = true;
            this.textBoxLongSec.Size = new System.Drawing.Size(64, 20);
            this.textBoxLongSec.TabIndex = 2;
            // 
            // textBoxLongMin
            // 
            this.textBoxLongMin.Location = new System.Drawing.Point(80, 40);
            this.textBoxLongMin.Name = "textBoxLongMin";
            this.textBoxLongMin.ReadOnly = true;
            this.textBoxLongMin.Size = new System.Drawing.Size(64, 20);
            this.textBoxLongMin.TabIndex = 1;
            // 
            // textBoxLongDeg
            // 
            this.textBoxLongDeg.Location = new System.Drawing.Point(8, 40);
            this.textBoxLongDeg.Name = "textBoxLongDeg";
            this.textBoxLongDeg.ReadOnly = true;
            this.textBoxLongDeg.Size = new System.Drawing.Size(64, 20);
            this.textBoxLongDeg.TabIndex = 0;
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.label4);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.textBoxLatDir);
            this.groupBox1.Controls.Add(this.textBoxLatSec);
            this.groupBox1.Controls.Add(this.textBoxLatMin);
            this.groupBox1.Controls.Add(this.textBoxLatDeg);
            this.groupBox1.Location = new System.Drawing.Point(8, 236);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(296, 72);
            this.groupBox1.TabIndex = 7;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Latitude";
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(224, 24);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(56, 16);
            this.label4.TabIndex = 7;
            this.label4.Text = "Direction";
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(152, 24);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(48, 16);
            this.label3.TabIndex = 6;
            this.label3.Text = "Second";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(80, 24);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(100, 16);
            this.label2.TabIndex = 5;
            this.label2.Text = "Minute";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 24);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(56, 16);
            this.label1.TabIndex = 4;
            this.label1.Text = "Degree";
            // 
            // textBoxLatDir
            // 
            this.textBoxLatDir.Location = new System.Drawing.Point(224, 40);
            this.textBoxLatDir.Name = "textBoxLatDir";
            this.textBoxLatDir.ReadOnly = true;
            this.textBoxLatDir.Size = new System.Drawing.Size(64, 20);
            this.textBoxLatDir.TabIndex = 3;
            // 
            // textBoxLatSec
            // 
            this.textBoxLatSec.Location = new System.Drawing.Point(152, 40);
            this.textBoxLatSec.Name = "textBoxLatSec";
            this.textBoxLatSec.ReadOnly = true;
            this.textBoxLatSec.Size = new System.Drawing.Size(64, 20);
            this.textBoxLatSec.TabIndex = 2;
            // 
            // textBoxLatMin
            // 
            this.textBoxLatMin.Location = new System.Drawing.Point(80, 40);
            this.textBoxLatMin.Name = "textBoxLatMin";
            this.textBoxLatMin.ReadOnly = true;
            this.textBoxLatMin.Size = new System.Drawing.Size(64, 20);
            this.textBoxLatMin.TabIndex = 1;
            // 
            // textBoxLatDeg
            // 
            this.textBoxLatDeg.Location = new System.Drawing.Point(8, 40);
            this.textBoxLatDeg.Name = "textBoxLatDeg";
            this.textBoxLatDeg.ReadOnly = true;
            this.textBoxLatDeg.Size = new System.Drawing.Size(64, 20);
            this.textBoxLatDeg.TabIndex = 0;
            // 
            // label14
            // 
            this.label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label14.Location = new System.Drawing.Point(315, 442);
            this.label14.Name = "label14";
            this.label14.Size = new System.Drawing.Size(72, 23);
            this.label14.TabIndex = 17;
            this.label14.Text = "Local Time:";
            // 
            // label13
            // 
            this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label13.Location = new System.Drawing.Point(315, 420);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(72, 23);
            this.label13.TabIndex = 16;
            this.label13.Text = "UTC Time:";
            // 
            // lblLocalTime
            // 
            this.lblLocalTime.AutoSize = true;
            this.lblLocalTime.Location = new System.Drawing.Point(393, 442);
            this.lblLocalTime.Name = "lblLocalTime";
            this.lblLocalTime.Size = new System.Drawing.Size(13, 13);
            this.lblLocalTime.TabIndex = 15;
            this.lblLocalTime.Text = "?";
            // 
            // lblUTCTime
            // 
            this.lblUTCTime.AutoSize = true;
            this.lblUTCTime.Location = new System.Drawing.Point(393, 420);
            this.lblUTCTime.Name = "lblUTCTime";
            this.lblUTCTime.Size = new System.Drawing.Size(13, 13);
            this.lblUTCTime.TabIndex = 14;
            this.lblUTCTime.Text = "?";
            // 
            // pBox
            // 
            this.pBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.pBox.Location = new System.Drawing.Point(318, 88);
            this.pBox.Name = "pBox";
            this.pBox.Size = new System.Drawing.Size(300, 300);
            this.pBox.TabIndex = 18;
            this.pBox.TabStop = false;
            this.pBox.Paint += new System.Windows.Forms.PaintEventHandler(this.pBox_Paint);
            // 
            // lstBaudRate
            // 
            this.lstBaudRate.Items.AddRange(new object[] {
            "110",
            "300",
            "600",
            "1200",
            "2400",
            "4800",
            "9600",
            "14400",
            "19200",
            "38400",
            "56000",
            "57600",
            "115200",
            "128000",
            "256000"});
            this.lstBaudRate.Location = new System.Drawing.Point(79, 25);
            this.lstBaudRate.Name = "lstBaudRate";
            this.lstBaudRate.Size = new System.Drawing.Size(64, 56);
            this.lstBaudRate.TabIndex = 19;
            // 
            // label15
            // 
            this.label15.AutoSize = true;
            this.label15.Location = new System.Drawing.Point(5, 9);
            this.label15.Name = "label15";
            this.label15.Size = new System.Drawing.Size(29, 13);
            this.label15.TabIndex = 20;
            this.label15.Text = "Port:";
            // 
            // label16
            // 
            this.label16.AutoSize = true;
            this.label16.Location = new System.Drawing.Point(76, 9);
            this.label16.Name = "label16";
            this.label16.Size = new System.Drawing.Size(61, 13);
            this.label16.TabIndex = 21;
            this.label16.Text = "Baud Rate:";
            // 
            // btnDetect
            // 
            this.btnDetect.Location = new System.Drawing.Point(149, 6);
            this.btnDetect.Name = "btnDetect";
            this.btnDetect.Size = new System.Drawing.Size(75, 23);
            this.btnDetect.TabIndex = 22;
            this.btnDetect.Text = "Detect";
            this.btnDetect.Click += new System.EventHandler(this.btnDetect_Click);
            // 
            // btnCancel
            // 
            this.btnCancel.Location = new System.Drawing.Point(229, 6);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.Size = new System.Drawing.Size(75, 23);
            this.btnCancel.TabIndex = 23;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // lblDetect
            // 
            this.lblDetect.AutoSize = true;
            this.lblDetect.Location = new System.Drawing.Point(229, 32);
            this.lblDetect.Name = "lblDetect";
            this.lblDetect.Size = new System.Drawing.Size(13, 13);
            this.lblDetect.TabIndex = 24;
            this.lblDetect.Text = "?";
            // 
            // gpsReceiver
            // 
            this.gpsReceiver.BaudRate = ZylGPSReceiver.SerialBaudRate.br004800;
            this.gpsReceiver.DataWidth = ZylGPSReceiver.SerialDataWidth.dw8Bits;
            this.gpsReceiver.EnableDTROnOpen = true;
            this.gpsReceiver.EnableRTSOnOpen = true;
            this.gpsReceiver.FlowControl = System.IO.Ports.Handshake.None;
            this.gpsReceiver.ForceCheckSum = true;
            this.gpsReceiver.LogDateTime = false;
            this.gpsReceiver.LogFile = null;
            this.gpsReceiver.LogNMEA = false;
            this.gpsReceiver.ParityBits = System.IO.Ports.Parity.None;
            this.gpsReceiver.Port = ZylGPSReceiver.SerialCommPort.COM02;
            this.gpsReceiver.ReadIntervalTimeout = -1;
            this.gpsReceiver.StopBits = System.IO.Ports.StopBits.One;
            this.gpsReceiver.WriteIntervalTimeout = -1;
            this.gpsReceiver.AltitudeChanged += new System.EventHandler<ZylGPSReceiver.ParamEventArgs>(this.gpsReceiver_AltitudeChanged);
            this.gpsReceiver.Position2DChanged += new System.EventHandler<ZylGPSReceiver.DMSPositionEventArgs>(this.gpsReceiver_Position2DChanged);
            this.gpsReceiver.Connected += new System.EventHandler<ZylGPSReceiver.ConnectionEventArgs>(this.gpsReceiver_Connected);
            this.gpsReceiver.SatellitesReceived += new System.EventHandler<System.EventArgs>(this.gpsReceiver_SatellitesReceived);
            this.gpsReceiver.Received += new System.EventHandler<ZylGPSReceiver.DataEventArgs>(this.serialPort_Received);
            this.gpsReceiver.LatitudeChanged += new System.EventHandler<ZylGPSReceiver.PositionEventArgs>(this.gpsReceiver_LatitudeChanged);
            this.gpsReceiver.HeadingChanged += new System.EventHandler<ZylGPSReceiver.ParamEventArgs>(this.gpsReceiver_HeadingChanged);
            this.gpsReceiver.Disconnected += new System.EventHandler<ZylGPSReceiver.ConnectionEventArgs>(this.gpsReceiver_Disconnected);
            this.gpsReceiver.SpeedChanged += new System.EventHandler<ZylGPSReceiver.ParamEventArgs>(this.gpsReceiver_SpeedChanged);
            this.gpsReceiver.Detecting += new ZylGPSReceiver.DetectEventHandler(this.gpsReceiver_Detecting);
            this.gpsReceiver.LongitudeChanged += new System.EventHandler<ZylGPSReceiver.PositionEventArgs>(this.gpsReceiver_LongitudeChanged);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(625, 476);
            this.Controls.Add(this.lblDetect);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnDetect);
            this.Controls.Add(this.label16);
            this.Controls.Add(this.label15);
            this.Controls.Add(this.lstBaudRate);
            this.Controls.Add(this.pBox);
            this.Controls.Add(this.label14);
            this.Controls.Add(this.label13);
            this.Controls.Add(this.lblLocalTime);
            this.Controls.Add(this.lblUTCTime);
            this.Controls.Add(this.groupBox3);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.btnClose);
            this.Controls.Add(this.btnOpen);
            this.Controls.Add(this.lstPorts);
            this.Controls.Add(this.textBoxOut);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "ZylGPSReceiver.NET Demo";
            this.Load += new System.EventHandler(this.Form1_Load);
            this.Closed += new System.EventHandler(this.Form1_Closed);
            this.groupBox3.ResumeLayout(false);
            this.groupBox3.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pBox)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{			
			gpsReceiver.Port = (SerialCommPort)(lstPorts.SelectedIndex + 1);
            gpsReceiver.BaudRate = (SerialBaudRate)(Convert.ToInt32(lstBaudRate.Items[lstBaudRate.SelectedIndex].ToString()));
            if (!gpsReceiver.Open())
                MessageBox.Show("Cannot connect to " + gpsReceiver.Port.ToString());
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{            
			gpsReceiver.Close();            
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			if (gpsReceiver != null)
				gpsReceiver.Close();
		}

        private void Set_textBoxOut(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxOut.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxOut);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxOut.Text = text;
                this.textBoxOut.SelectionStart = textBoxOut.Text.Length;
                this.textBoxOut.SelectionLength = 0;
                this.textBoxOut.ScrollToCaret();
            }
        }

        private void Set_lblUTCTime(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.lblUTCTime.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_lblUTCTime);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.lblUTCTime.Text = text;                
            }
        }

        private void Set_lblLocalTime(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.lblLocalTime.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_lblLocalTime);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.lblLocalTime.Text = text;
            }
        }

        private void Set_textBoxLatDeg(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatDeg.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatDeg);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatDeg.Text = text;
            }
        }

        private void Set_textBoxLatMin(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatMin.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatMin);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatMin.Text = text;
            }
        }

        private void Set_textBoxLatSec(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatSec.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatSec);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatSec.Text = text;
            }
        }

        private void Set_textBoxLatDir(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLatDir.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLatDir);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLatDir.Text = text;
            }
        }

        private void Set_textBoxLongDeg(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongDeg.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongDeg);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongDeg.Text = text;
            }
        }

        private void Set_textBoxLongMin(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongMin.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongMin);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongMin.Text = text;
            }
        }

        private void Set_textBoxLongSec(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongSec.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongSec);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongSec.Text = text;
            }
        }

        private void Set_textBoxLongDir(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxLongDir.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxLongDir);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxLongDir.Text = text;
            }
        }

        private void Set_textBoxAlt(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxAlt.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxAlt);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxAlt.Text = text;
            }
        }

        private void Set_textBoxSpeed(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxSpeed.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxSpeed);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxSpeed.Text = text;
            }
        }

        private void Set_textBoxHeading(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxHeading.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxHeading);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxHeading.Text = text;
            }
        }

        private void Set_textBoxSatCount(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxSatCount.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxSatCount);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.textBoxSatCount.Text = text;
            }
        }

        private void Set_lblDetect(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.lblDetect.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_lblDetect);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                this.lblDetect.Text = text;
            }
        }

		private void serialPort_Received(object sender, ZylGPSReceiver.DataEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + e.Buffer);			

			Set_lblUTCTime(gpsReceiver.Position.GetUTCDateTime().ToString());
			Set_lblLocalTime(gpsReceiver.Position.GetLocalDateTime().ToString());

			Set_textBoxLatDeg(gpsReceiver.Position.LatitudeDegree.ToString());
			Set_textBoxLatMin(gpsReceiver.Position.LatitudeMinute.ToString());
			Set_textBoxLatSec(gpsReceiver.Position.LatitudeSecond.ToString());
			if (gpsReceiver.Position.LatitudeDirection == GPSPosition.CardinalPoint.North)
				Set_textBoxLatDir("North");
			else
				Set_textBoxLatDir("South");

			Set_textBoxLongDeg(gpsReceiver.Position.LongitudeDegree.ToString());
            Set_textBoxLongMin(gpsReceiver.Position.LongitudeMinute.ToString());
            Set_textBoxLongSec(gpsReceiver.Position.LongitudeSecond.ToString());
			if (gpsReceiver.Position.LongitudeDirection == GPSPosition.CardinalPoint.East)
                Set_textBoxLongDir("East");
			else
                Set_textBoxLongDir("West");

            Set_textBoxAlt(gpsReceiver.Position.Altitude.ToString());
            Set_textBoxSpeed(gpsReceiver.Position.SpeedAsKmh.ToString());
            Set_textBoxHeading(gpsReceiver.Position.Heading.ToString());
            Set_textBoxSatCount(gpsReceiver.Position.SatelliteCount.ToString());            
        }

		private void gpsReceiver_LatitudeChanged(object sender, ZylGPSReceiver.PositionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Latitude changed: " + 
				GPSPosition.DMSToDecimalDegrees(e.Degree, e.Minute, e.Second, 
				e.Direction).ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_LongitudeChanged(object sender, ZylGPSReceiver.PositionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Longitude changed: " + 
				GPSPosition.DMSToDecimalDegrees(e.Degree, e.Minute, e.Second, 
				e.Direction).ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_AltitudeChanged(object sender, ZylGPSReceiver.ParamEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Altitude changed: " + e.Value.ToString() + " m" + Environment.NewLine);		
		}

		private void gpsReceiver_Connected(object sender, ZylGPSReceiver.ConnectionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Connected to: " + e.Port.ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_Disconnected(object sender, ZylGPSReceiver.ConnectionEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Disconnected from: " + e.Port.ToString() + Environment.NewLine);			
		}

		private void gpsReceiver_HeadingChanged(object sender, ZylGPSReceiver.ParamEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Heading changed: " + e.Value.ToString() + " degrees" + Environment.NewLine);		
		}

		private void gpsReceiver_SpeedChanged(object sender, ZylGPSReceiver.ParamEventArgs e)
		{
			Set_textBoxOut(textBoxOut.Text + "Speed changed: " + e.Value.ToString() + " km/h" + Environment.NewLine);		
		}

        private void btnDetect_Click(object sender, EventArgs e)
        {
            SerialCommPort port;
			SerialBaudRate baudRate;
            m_DetectCancel = false;
			if (gpsReceiver.FastDetectGPS(out port, out baudRate))
			{
				MessageBox.Show("Port: " + GPSReceiver.SerialCommPortToString(port) + ", Baud Rate: " + baudRate.ToString());
				lstPorts.SelectedIndex = lstPorts.Items.IndexOf(GPSReceiver.SerialCommPortToString(port));
				lstBaudRate.SelectedIndex = lstBaudRate.Items.IndexOf(((int)baudRate).ToString());
			}
			else
				MessageBox.Show("No GPS detected.");
            lblDetect.Text = "";
		}

        private void Form1_Load(object sender, EventArgs e)
        {
            lstBaudRate.SelectedIndex = 5;
        }

        private void RefreshPaintBox()
        {
            try
            {
                // InvokeRequired required compares the thread ID of the
                // calling thread to the thread ID of the creating thread.
                // If these threads are different, it returns true.
                if (this.InvokeRequired)
                {
                    this.BeginInvoke(new RefreshPaintBoxCallBack(RefreshPaintBox));
                    return;
                }

                this.pBox.Refresh();
            }
            catch { }
        }

        private void gpsReceiver_SatellitesReceived(object sender, EventArgs e)
        {
            RefreshPaintBox();
        }

        private void pBox_Paint(object sender, PaintEventArgs e)
        {
            gpsReceiver.DrawSatellites(e.Graphics, pBox.Width/2, Color.Black, Color.White);
        }

        private void gpsReceiver_Detecting(object sender, DetectEventArgs e, ref bool cancel)
        {
            Set_lblDetect("Detecting: " + e.Port.ToString() + " " + e.BaudRate.ToString());
            cancel = m_DetectCancel;
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            m_DetectCancel = true;
        }

        private void gpsReceiver_Position2DChanged(object sender, DMSPositionEventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + "Position2D changed." + Environment.NewLine);	
        }		
    }    
}
